
/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	EmetteurUDP.c

	Il s'agit d'envoyer un message ailleurs
	Le programme prend en entree le nom d'une
	machine et un numero de port et il transmet
	les messages a ce numero de port jusqu'a
	ce qu'on lui donne le message stop compose
	d'un message constitue exclusivement d'un "."    
	
\*================================================*/


#include "SocketToolbox.h"

	
void main(int argc, char **argv)
/*================================================*\
	Une fois que la socket est attachee, elle 
	attend que l'utilisateur tape quelque chose 
	a l'ecran. Ensuite, ce message est emis a
	la machine destinatrice au port de destination.
	Et ce, jusqu'a ce que le message en question 
	soit exclusivement limite a "."
\*================================================*/
{	
	int message_size, desc_sock, res;
	char message[100];
	struct sockaddr_in adresse_loc, adresse_dist; 
	
	if(argc!=3) 
	{printf("Usage : emetteur mach_dist port_dist\n"); exit(1);}
	
/*-------- Creation et attachement de la socket locale ----*/
	
	desc_sock = GetAndBindSocket(SOCK_DGRAM, 
		atoi(argv[1]), &adresse_loc);
	
	printf("Emetteur connecte sur le port %d\n",
		adresse_loc.sin_port);
		
/*-------- Preparation de l'adresse distante ------------*/

	adresse_dist = WriteNetworkAddress(argv[1], atoi(argv[2]));
	
/*----- Boucle de lecture et envoi des messages ---------*/

	while(strcmp(message,".")!=0)
	{
		/* ----- saisi du message au clavier ----*/
		printf("message >> ");
		gets(message);
		
		res=sendto(desc_sock, 
			message, 
			strlen(message)+1, 0, 
			(struct sockaddr *)&adresse_dist, 
			sizeof(adresse_dist));
		if(res==-1) {perror("sendto"); exit(1);}
	}
	printf("Arret de l'emetteur.\n");
}
