
/*===============================================*\
	Samedi 21 novembre 1998

	Arash HABIBI

	AppliEmission.c

	Ce qui utilise les services de HDLC. 
	En l'occurrence un transfert de fichier. 

\*================================================*/


#include "Liaison.h"

void main(int argc, char **argv)
/*===============================================*\
  fichier en lecture, lit le fichier et l'envoie 
  sur la socket avec la fonction SendMessage() qui 
  est definie ci-dessus. 
\*===============================================*/
{
    int ReadFile, taille, desc;
    mode_t mode; 
    char paquet[MAX_PAQUET];
	
    if(argc!=2)
	{printf("Usage : emetteur FichAEmettre \n");
	 exit(1);}

    mode = S_IRUSR|S_IWUSR; 

    if((ReadFile=open(argv[1], O_RDONLY, mode))==-1)
      {perror(argv[1]); exit(1);}

    desc = LiaConnectRequest("sock_emit", "s_medem");
	
    while((taille = read(ReadFile, paquet, MAX_MESSAGE))>0)
      LiaDataRequest(desc, paquet, taille);

    if(taille<0)
      {printf("Appli : Erreur irrecuperable.\n"); exit(1);}
    else
      {
	printf("Appli : Emission terminee.\n");
	LiaDisconnectRequest(desc);
	close(ReadFile);
      }
}
