/*==================================================*\

  Vendredi 31 Juillet 1998

  Arash Habibi

  Timer.c


  Dans la perspective de me faire un vfilm, je veux
  faire un processus qui me delivre un top tous 
  les 1/25 seconde. 

\*==================================================*/


#include <stdio.h>
#include <sys/time.h>
#include <sys/signal.h>

struct itimerval timer; 
struct itimerval old_timer; 
struct sigaction p_action2_anc, p_action2; 

sigset_t _masque; 
sigset_t _demasque; 


void Reponse2()
{
  static int nb_appels=0; 

    if(nb_appels==1)
    fprintf(stderr,"=================>>>>>> timer <<<<<================\n");
    nb_appels = (nb_appels + 1)%2; 
}



void main()
{
    int i; 
    char c; 

    timer.it_interval.tv_sec =  2; 
    timer.it_interval.tv_usec = 0;

    timer.it_value.tv_sec = 0; 
    timer.it_value.tv_usec = 1; 

    p_action2.sa_handler = &Reponse2; 

    sigaction(SIGALRM, &p_action2, &p_action2_anc); 

    sigemptyset(&_demasque); 
    sigemptyset(&_masque); 
    sigaddset(&_masque, SIGALRM); 

    sigprocmask(SIG_SETMASK, &_masque, NULL); 
    
    setitimer(ITIMER_REAL, &timer, &old_timer); 
    
    for(i=0; i<5; i++)
      {
	sigprocmask(SIG_SETMASK, &_masque, NULL); 
	scanf("%c", &c);
	sigprocmask(SIG_SETMASK, &_demasque, NULL);     
	pause();
      }
}

