
/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	UnixDgrmEmetteur.c

	Le programme est identique a BindUnix.c
	dans sa premiere partie. Le programme doit
	etre lance avec l'adresse de la socket locale
	et de la socket distante. Ensuite, avec la 
	primitive sendto, on envoie un message a 
	la socket distante.     
	
\*================================================*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>

struct sockaddr_un adresse_loc, adresse_dist; 

void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{
	struct sockaddr_un *adrloc_p, *adrdist_p; 
	int desc, res;
	char message[100];	
	
	if(argc!=3) {printf("Usage : emetteur socket_loc socket_dist\n"); 
			exit(1);}
			
/* ----- creation de la socket ----- */

	desc = socket(AF_UNIX, SOCK_DGRAM, 0);

	if(desc == -1) {perror("socket"); exit(1);}
	else printf("Socket d'emission creee.\n");
	
	
/* ----- preparation de l'adresse locale ----- */

	adrloc_p = &adresse_loc; 
	adrloc_p->sun_family = AF_UNIX; 
	strcpy(adrloc_p->sun_path, argv[1]);
	
/* ----- et attachement de la socket a   ----- */
/* ----- l'adresse par bind              ----- */
	
	res = bind(desc, (struct sockaddr*)adrloc_p, 
		sizeof(adresse_loc));

	if(res == -1) {perror("bind"); exit(1);}
	else printf("Socket d'emission attachee.\n");
	
		
/*--------- Nouveau par rapport a BindUnix.c ---------------*/

/* ------ Preparation de l'adresse de la socket distante -- */ 

	adrdist_p = &adresse_dist; 	
	adrdist_p->sun_family = AF_UNIX; 
	strcpy(adrdist_p->sun_path, argv[2]);
	
/* ----- saisi du message au clavier -----------------------*/
	
	printf("message >> ");
	gets(message); 
	
	
/* ---- Envoi du message -----------------------------------*/

	res = sendto(desc, message, 
		strlen(message)+1, 0, 
		(struct sockaddr*) adrdist_p,
		sizeof(adresse_dist));

	if(res==-1) {perror("sendto emetteur"); exit(1);}
	else printf("Emetteur : message envoye.\n");
}	 
