
/*===============================================*\
	Vendredi 11 Septembre 1998

	Arash HABIBI

	SocketToolbox.h

 	Un ensemble de fonctions qu'on utilise
	partout en manipulant les sockets.  
	
\*================================================*/


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h>
#include <string.h>


typedef struct AdresseIP_t
{
	unsigned int n1, n2, n3, n4;
} AdresseIP_t; 


extern u_long IPAddrByName(char *);
extern void LongToAdresseIP(u_long , AdresseIP_t *);
extern struct sockaddr_in WriteNetworkAddress(char *, u_short);
extern void ReadNetworkAddress(struct sockaddr_in , AdresseIP_t *, u_short *);
extern int GetAndBindSocket(int, short, struct sockaddr_in *);
